=== libs/backends/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf

def options(opt):
    pass

def configure(conf):
    autowaf.set_recursive()

    backends = conf.env['BACKENDS']
    for i in backends:
        conf.recurse(i)

def build(bld):
    backends = bld.env['BACKENDS']

    for i in backends:
        bld.recurse(i)
