=== libs/ctrl-interface/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf

children = [
    'control_protocol',
    'midi_surface'
]

def options(opt):
    pass

def sub_config_and_use(conf, name, has_objects = True):
    conf.recurse(name)
    autowaf.set_local_lib(conf, name, has_objects)

def configure(conf):
    global children
    autowaf.set_recursive()
    for i in children:
        sub_config_and_use(conf, i)

def build(bld):
    global children
    for i in children:
        bld.recurse(i)

def shutdown():
    autowaf.shutdown()
